/*global module require*/
(function(){"use strict";
	function Vector4 (vec) {return this.initVector4(vec);}
	var Vector3 = require('./Vector3'),
	    vector4 = Vector4.prototype;
	Vector4.check = function (obj) {
		return Vector3.check(obj) && obj.initVector4 === vector4.initVector4;
	};
	Vector4.create = function (obj, args) {
		obj = obj || [];
		if (!Vector3.check(obj)) Vector3.create(obj);
		obj.length = 4;
		obj.initVector4 = vector4.initVector4 || function (vec) {
			vec = vec || [];
			this[0] = vec[0] || 0;
			this[1] = vec[1] || 0;
			this[2] = vec[2] || 0;
			this[3] = vec[3] || 0;
			return this;
		};
		obj.set = function (vec) {
			return this.initVector4(vec);
		};
		obj.copy = function (vec) {
			return new Vector4(this);
		};
		obj.toArray = function () {
			return [this[0], this[1], this[2], this[4]];
		};
		if (args) obj.initVector4.apply(obj, args);
		return obj;
	};
	(module.exports = Vector4).create(vector4);
}).call(this);