/*global exports Float64Array*/
(function(){"use strict";
	var utils = exports;
	utils.degToRad = function (deg) {
		return deg * Math.PI / 180;
	};
	utils.hexToRGB = function (hex) {
		hex = hex.toString(16);
		var r = parseInt(hex.substring(0, 2), 16),
		    g = parseInt(hex.substring(2, 4), 16),
		    b = parseInt(hex.substring(4, 6), 16);
		return [r, g, b];
	};
	utils.rgbToHex = function (r, g, b) {
		return utils.toHex(r) + utils.toHex(g) + utils.toHex(b);
	};
	utils.toHex = function (n) {
		if (n === undefined) return '00';
		n = parseInt(n, 10);
		if (n === 0 || isNaN(n)) return '00';
		n = Math.max(0, n);
		n = Math.min(n, 255);
		n = Math.round(n);
		var chars = '0123456789ABCDEF';
		return chars.charAt((n - n % 16) / 16) +
			chars.charAt(n % 16);
	};
	utils.square = function (n) {
		return n * n;
	};
	utils.hypot = function (a, b) {
		return Math.sqrt(a*a + b*b);
	};
	utils.polar = function (x, y) {
		var theta = Math.atan2(y, x),
		    r = utils.hypot(x, y);

		return new Float64Array([r, theta]);
	};
	utils.cartesian = function (r, theta) {
		var x = r * Math.cos(theta),
		    y = r * Math.sin(theta);

		return new Float64Array([x, y]);
	};
}).call(this);