/**
 * glMath.js - WebGL math library with matrix and vector operations based on glMatrix.js
 * MIT License - (c) Roland Poulter 2011
 */
(function(){var a=function(){"use strict";var a={};return{require:function(b,c){function e(){c.charAt(c.length-1)!=="/"&&(c+="/"),b=c+b}c=c||"/";var d=b.charAt(0);d==="."?(d=b.charAt(1),d==="."&&b.charAt(2)==="/"?(c.charAt(c.length-1)==="/"&&(c=c.substring(0,c.length-1)),c=c.substring(0,c.lastIndexOf("/")),b=c+b.substr(2)):d==="/"?b=c+b.substr(2):e()):d!=="/"&&e(),b.charAt(0)!=="/"&&(b="/"+b);return a[b].install()},provide:function(b,c){var d=this.require;a[b]={exports:{},factory:c,require:function(a){var c=b.substring(0,b.lastIndexOf("/"));return d(a,c+"/")},install:function f(){var a=f;this.install=function(b){if(b)return a.call(this);return this.exports},this.factory(this.require,this,this.exports);return this.install()}};return this},freeze:function(a,b){delete this.provide,a&&b&&(this.conflict=b[a],this.noConflict=function(){return b[a]=this.conflict||this},b[a]=this);return this}}}.call(this);a.provide("/utils",function(a,b,c){(function(){"use strict";var a=c;a.degToRad=function(a){return a*Math.PI/180},a.hexToRGB=function(a){a=a.toString(16);var b=parseInt(a.substring(0,2),16),c=parseInt(a.substring(2,4),16),d=parseInt(a.substring(4,6),16);return[b,c,d]},a.rgbToHex=function(b,c,d){return a.toHex(b)+a.toHex(c)+a.toHex(d)},a.toHex=function(a){if(a===undefined)return"00";a=parseInt(a,10);if(a===0||isNaN(a))return"00";a=Math.max(0,a),a=Math.min(a,255),a=Math.round(a);var b="0123456789ABCDEF";return b.charAt((a-a%16)/16)+b.charAt(a%16)},a.square=function(a){return a*a},a.hypot=function(a,b){return Math.sqrt(a*a+b*b)},a.polar=function(b,c){var d=Math.atan2(c,b),e=a.hypot(b,c);return new Float64Array([e,d])},a.cartesian=function(a,b){var c=a*Math.cos(b),d=a*Math.sin(b);return new Float64Array([c,d])}}).call(this)}),a.provide("/Vector3",function(a,b,c){(function(){function a(a){return this.initVector3(a)}"use strict";var c=a.prototype;a.check=function(a){return a&&a.initVector3===c.initVector3},a.create=function(b,d){b=b||[],b.length=3,b.initVector3=c.initVector3||function(a){a=a||[],this[0]=a[0]||0,this[1]=a[1]||0,this[2]=a[2]||0;return this},b.set=function(a){return this.initVector3(a)},b.copy=function(b){return new a(this)},b.add=function(a){this[0]+=a[0],this[1]+=a[1],this[2]+=a[2];return this},b.subtract=function(a){this[0]-=a[0],this[1]-=a[1],this[2]-=a[2];return this},b.negate=function(a){this[0]=-this[0],this[1]=-this[1],this[2]=-this[2];return this},b.multiply=function(a){this[0]*=a[0],this[1]*=a[1],this[2]*=a[2];return this},b.divide=function(a){this[0]/=a[0],this[1]/=a[1],this[2]/=a[2];return this},b.scale=function(a){this[0]*=a,this[1]*=a,this[2]*=a;return this},b.zero=function(){this[0]=this[1]=this[2]=0;return this},b.normalize=function(){var a=this.len();a?a!==1&&(a=1/a,this[0]*=a,this[1]*=a,this[2]*=a):this.zero();return this},b.direction=function(a){var b=this.copy().subtract(a),c=b.len();c?(c=1/c,this[0]=b[0]*c,this[1]=b[1]*c,this[2]=b[2]*c):this.zero();return this},b.len=function(){return Math.sqrt(this.dot(this))},b.dot=function(a){return this[0]*a[0]+this[1]*a[1]+this[2]*a[2]},b.cross=function(a){var b=this[0],c=this[1],d=this[2],e=a[0],f=a[1],g=a[2];this[0]=c*g-d*f,this[1]=d*e-b*g,this[2]=b*f-c*e;return this},b.lerp=function(a,b){var c=this[0],d=this[1],e=this[2];this[0]=c+b*(a[0]-c),this[1]=d+b*(a[1]-d),this[2]=e+b*(a[2]-e);return this},b.toString=b.str=function(a){return this.toArray().join(",")},b.toArray=function(){return[this[0],this[1],this[2]]},b.toFloat32Array=function(){return new Float32Array(this.toArray())},b.toFloat64Array=function(){return new Float64Array(this.toArray())};return b},(b.exports=a).create(c)}).call(this)}),a.provide("/Vector4",function(a,b,c){(function(){function c(a){return this.initVector4(a)}"use strict";var d=a("./Vector3"),e=c.prototype;c.check=function(a){return d.check(a)&&a.initVector4===e.initVector4},c.create=function(a,b){a=a||[],d.check(a)||d.create(a),a.length=4,a.initVector4=e.initVector4||function(a){a=a||[],this[0]=a[0]||0,this[1]=a[1]||0,this[2]=a[2]||0,this[3]=a[3]||0;return this},a.set=function(a){return this.initVector4(a)},a.copy=function(a){return new c(this)},a.toArray=function(){return[this[0],this[1],this[2],this[4]]},b&&a.initVector4.apply(a,b);return a},(b.exports=c).create(e)}).call(this)}),a.provide("/Matrix3",function(a,b,c){(function(){function a(a){return this.initMatrix3(a)}"use strict";var c=a.prototype;a.check=function(a){return a&&a.initMatrix3===c.initMatrix3},a.create=function(b,d){b=b||[],b.length=9,b.initMatrix3=c.initMatrix3||function(a){a=a||[],this[0]=a[0]||0,this[1]=a[1]||0,this[2]=a[2]||0,this[3]=a[3]||0,this[4]=a[4]||0,this[5]=a[5]||0,this[6]=a[6]||0,this[7]=a[7]||0,this[8]=a[8]||0;return this},b.set=function(a){return this.initMatrix3(a)},b.copy=function(){return new a(this)},b.identity=function(){return this.set([1,0,0,0,1,0,0,0,1])},b.transpose=function(a){var b,c,d;a?(this[0]=a[0],this[1]=a[3],this[2]=a[6],this[3]=a[1],this[4]=a[4],this[5]=a[7],this[6]=a[2],this[7]=a[5],this[8]=a[8]):(b=this[1],c=this[2],d=this[5],this[1]=this[3],this[2]=this[6],this[3]=b,this[5]=this[7],this[6]=c,this[7]=d);return this},b.forEach=function(a,b){if(typeof a!="function")return this;b=b||this;for(var c=0,d=this.length;c<d;c+=1)a.call(b,this[c],c,this);return this},b.toMat4=function(){return[this[0],this[1],this[2],0,this[3],this[4],this[5],0,this[6],this[7],this[8],0,0,0,0,1]},b.toString=b.str=function(){return this.toArray().join(",")},b.toArray=function(){return[this[0],this[1],this[2],this[3],this[4],this[5],this[6],this[7],this[8]]},b.toFloat32Array=function(){return new Float32Array(this.toArray())},b.toFloat64Array=function(){return new Float64Array(this.toArray())},d&&b.initMatrix3.apply(b,d);return b},(b.exports=a).create(c)}).call(this)}),a.provide("/Matrix4",function(a,b,c){(function(){function c(a){return this.initMatrix4(a)}"use strict";var d=a("./Matrix3"),e=c.prototype;c.check=function(a){return d.check(a)&&a.initMatrix4===e.initMatrix4},c.create=function(a,b){a=a||[],d.check(a)||d.create(a),a.length=16,a.initMatrix4=e.initMatrix4||function(a){a=a||[],this[0]=a[0]||0,this[1]=a[1]||0,this[2]=a[2]||0,this[3]=a[3]||0,this[4]=a[4]||0,this[5]=a[5]||0,this[6]=a[6]||0,this[7]=a[7]||0,this[8]=a[8]||0,this[9]=a[9]||0,this[10]=a[10]||0,this[11]=a[11]||0,this[12]=a[12]||0,this[13]=a[13]||0,this[14]=a[14]||0,this[15]=a[15]||0;return this},a.set=function(a){return this.initMatrix4(a)},a.copy=function(){return new c(this)},a.identity=function(){return this.set([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])},a.transpose=function(a){var b,c,d,e,f,g;a?(this[0]=a[0],this[1]=a[4],this[2]=a[8],this[3]=a[12],this[4]=a[1],this[5]=a[5],this[6]=a[9],this[7]=a[13],this[8]=a[2],this[9]=a[6],this[10]=a[10],this[11]=a[14],this[12]=a[3],this[13]=a[7],this[14]=a[11],this[15]=a[15]):(b=this[1],c=this[2],d=this[3],e=this[6],f=this[7],g=this[11],this[1]=this[4],this[2]=this[8],this[3]=this[12],this[4]=b,this[6]=this[9],this[7]=this[13],this[8]=c,this[9]=e,this[11]=this[14],this[12]=d,this[13]=f,this[14]=g);return this},a.determinant=function(){var a=this[0],b=this[1],c=this[2],d=this[3],e=this[4],f=this[5],g=this[6],h=this[7],i=this[8],j=this[9],k=this[10],l=this[11],m=this[12],n=this[13],o=this[14],p=this[15];return m*j*g*d-i*n*g*d-m*f*k*d+e*n*k*d+i*f*o*d-e*j*o*d-m*j*c*h+i*n*c*h+m*b*k*h-a*n*k*h-i*b*o*h+a*j*o*h+m*f*c*l-e*n*c*l-m*b*g*l+a*n*g*l+e*b*o*l-a*f*o*l-i*f*c*p+e*j*c*p+i*b*g*p-a*j*g*p-e*b*k*p+a*f*k*p},a.inverse=function(){var a=this[0],b=this[1],c=this[2],d=this[3],e=this[4],f=this[5],g=this[6],h=this[7],i=this[8],j=this[9],k=this[10],l=this[11],m=this[12],n=this[13],o=this[14],p=this[15],q=a*f-b*e,r=a*g-c*e,s=a*h-d*e,t=b*g-c*f,u=b*h-d*f,v=c*h-d*g,w=i*n-j*m,x=i*o-k*m,y=i*p-l*m,z=j*o-k*n,A=j*p-l*n,B=k*p-l*o,C=1/(q*B-r*A+s*z+t*y-u*x+v*w);this[0]=(f*B-g*A+h*z)*C,this[1]=(-b*B+c*A-d*z)*C,this[2]=(n*v-o*u+p*t)*C,this[3]=(-j*v+k*u-l*t)*C,this[4]=(-e*B+g*y-h*x)*C,this[5]=(a*B-c*y+d*x)*C,this[6]=(-m*v+o*s-p*r)*C,this[7]=(i*v-k*s+l*r)*C,this[8]=(e*A-f*y+h*w)*C,this[9]=(-a*A+b*y-d*w)*C,this[10]=(m*u-n*s+p*q)*C,this[11]=(-i*u+j*s-l*q)*C,this[12]=(-e*z+f*x-g*w)*C,this[13]=(a*z-b*x+c*w)*C,this[14]=(-m*t+n*r-o*q)*C,this[15]=(i*t-j*r+k*q)*C;return this},a.toRotationMat=function(){return[this[0],this[1],this[2],this[3],this[4],this[5],this[6],this[7],this[8],this[9],this[10],this[11],0,0,0,1]},a.toMat3=function(){return[this[0],this[1],this[2],this[4],this[5],this[6],this[8],this[9],this[10]]},a.toInverseMat3=function(){var a=this[0],b=this[1],c=this[2],d=this[4],e=this[5],f=this[6],g=this[8],h=this[9],i=this[10],j=i*e-f*h,k=-i*d+f*g,l=h*d-e*g,m=a*j+b*k+c*l,n;if(!m)return null;n=1/m;return[j*n,(-i*b+c*h)*n,(f*b-c*e)*n,k*n,(i*a-c*g)*n,(-f*a+c*d)*n,l*n,(-h*a+b*g)*n,(e*a-b*d)*n]},a.multiply=function(a){var b=this[0],c=this[1],d=this[2],e=this[3],f=this[4],g=this[5],h=this[6],i=this[7],j=this[8],k=this[9],l=this[10],m=this[11],n=this[12],o=this[13],p=this[14],q=this[15],r=a[0],s=a[1],t=a[2],u=a[3],v=a[4],w=a[5],x=a[6],y=a[7],z=a[8],A=a[9],B=a[10],C=a[11],D=a[12],E=a[13],F=a[14],G=a[15];this[0]=r*b+s*f+t*j+u*n,this[1]=r*c+s*g+t*k+u*o,this[2]=r*d+s*h+t*l+u*p,this[3]=r*e+s*i+t*m+u*q,this[4]=v*b+w*f+x*j+y*n,this[5]=v*c+w*g+x*k+y*o,this[6]=v*d+w*h+x*l+y*p,this[7]=v*e+w*i+x*m+y*q,this[8]=z*b+A*f+B*j+C*n,this[9]=z*c+A*g+B*k+C*o,this[10]=z*d+A*h+B*l+C*p,this[11]=z*e+A*i+B*m+C*q,this[12]=D*b+E*f+F*j+G*n,this[13]=D*c+E*g+F*k+G*o,this[14]=D*d+E*h+F*l+G*p,this[15]=D*e+E*i+F*m+G*q;return this},a.multiplyVec3=function(a){var b=a[0],c=a[1],d=a[2];a[0]=this[0]*b+this[4]*c+this[8]*d+this[12],a[1]=this[1]*b+this[5]*c+this[9]*d+this[13],a[2]=this[2]*b+this[6]*c+this[10]*d+this[14];return this},a.multiplyVec4=function(a){var b=a[0],c=a[1],d=a[2],e=a[3];a[0]=this[0]*b+this[4]*c+this[8]*d+this[12]*e,a[1]=this[1]*b+this[5]*c+this[9]*d+this[13]*e,a[2]=this[2]*b+this[6]*c+this[10]*d+this[14]*e,a[3]=this[3]*b+this[7]*c+this[11]*d+this[15]*e;return this},a.translate=function(a){var b=a[0],c=a[1],d=a[2];this[12]=this[0]*b+this[4]*c+this[8]*d+this[12],this[13]=this[1]*b+this[5]*c+this[9]*d+this[13],this[14]=this[2]*b+this[6]*c+this[10]*d+this[14],this[15]=this[3]*b+this[7]*c+this[11]*d+this[15];return this},a.scale=function(a){var b=a[0],c=a[1],d=a[2];this[0]*=b,this[1]*=b,this[2]*=b,this[3]*=b,this[4]*=c,this[5]*=c,this[6]*=c,this[7]*=c,this[8]*=d,this[9]*=d,this[10]*=d,this[11]*=d;return this},a.rotate=function(a,b){var c=b[0],d=b[1],e=b[2],f=Math.sqrt(c*c+d*d+e*e);if(!f)return null;f!==1&&(f=1/f,c*=f,d*=f,e*=f);var g=Math.sin(a),h=Math.cos(a),i=1-h,j=this[0],k=this[1],l=this[2],m=this[3],n=this[4],o=this[5],p=this[6],q=this[7],r=this[8],s=this[9],t=this[10],u=this[11],v=c*c*i+h,w=d*c*i+e*g,x=e*c*i-d*g,y=c*d*i-e*g,z=d*d*i+h,A=e*d*i+c*g,B=c*e*i+d*g,C=d*e*i-c*g,D=e*e*i+h;this[0]=j*v+n*w+r*x,this[1]=k*v+o*w+s*x,this[2]=l*v+p*w+t*x,this[3]=m*v+q*w+u*x,this[4]=j*y+n*z+r*A,this[5]=k*y+o*z+s*A,this[6]=l*y+p*z+t*A,this[7]=m*y+q*z+u*A,this[8]=j*B+n*C+r*D,this[9]=k*B+o*C+s*D,this[10]=l*B+p*C+t*D,this[11]=m*B+q*C+u*D;return this},a.rotateX=function(a){var b=Math.sin(a),c=Math.cos(a),d=this[4],e=this[5],f=this[6],g=this[7],h=this[8],i=this[9],j=this[10],k=this[11];this[4]=d*c+h*b,this[5]=e*c+i*b,this[6]=f*c+j*b,this[7]=g*c+k*b,this[8]=d*-b+h*c,this[9]=e*-b+i*c,this[10]=f*-b+j*c,this[11]=g*-b+k*c;return this},a.rotateY=function(a){var b=Math.sin(a),c=Math.cos(a),d=this[0],e=this[1],f=this[2],g=this[3],h=this[8],i=this[9],j=this[10],k=this[11];this[0]=d*c+h*-b,this[1]=e*c+i*-b,this[2]=f*c+j*-b,this[3]=g*c+k*-b,this[8]=d*b+h*c,this[9]=e*b+i*c,this[10]=f*b+j*c,this[11]=g*b+k*c;return this},a.rotateZ=function(a){var b=Math.sin(a),c=Math.cos(a),d=this[0],e=this[1],f=this[2],g=this[3],h=this[4],i=this[5],j=this[6],k=this[7];this[0]=d*c+h*b,this[1]=e*c+i*b,this[2]=f*c+j*b,this[3]=g*c+k*b,this[4]=d*-b+h*c,this[5]=e*-b+i*c,this[6]=f*-b+j*c,this[7]=g*-b+k*c;return this},a.frustum=function(a,b,c,d,e,f){var g=b-a,h=d-c,i=f-e;this[0]=e*2/g,this[1]=0,this[2]=0,this[3]=0,this[4]=0,this[5]=e*2/h,this[6]=0,this[7]=0,this[8]=(b+a)/g,this[9]=(d+c)/h,this[10]=-(f+e)/i,this[11]=-1,this[12]=0,this[13]=0,this[14]=-(f*e*2)/i,this[15]=0;return this},a.perspective=function(a,b,c,d){var e=c*Math.tan(a*Math.PI/360),f=e*b;return this.frustum(-f,f,-e,e,c,d)},a.ortho=function(a,b,c,d,e,f){var g=b-a,h=d-c,i=f-e;this[0]=2/g,this[1]=0,this[2]=0,this[3]=0,this[4]=0,this[5]=2/h,this[6]=0,this[7]=0,this[8]=0,this[9]=0,this[10]=-2/i,this[11]=0,this[12]=-(a+b)/g,this[13]=-(d+c)/h,this[14]=-(f+e)/i,this[15]=1;return this},a.lookAt=function(a,b,c){var d=a[0],e=a[1],f=a[2],g=c[0],h=c[1],i=c[2],j=b[0],k=b[1],l=b[2],m,n,o,p,q,r,s,t,u,v;if(d===j&&e===k&&f===l)return this.identity();m=d-b[0],n=e-b[1],o=f-b[2],v=1/Math.sqrt(m*m+n*n+o*o),m*=v,n*=v,o*=v,p=h*o-i*n,q=i*m-g*o,r=g*n-h*m,v=Math.sqrt(p*p+q*q+r*r),v?(v=1/v,p*=v,q*=v,r*=v):(p=0,q=0,r=0),s=n*r-o*q,t=o*p-m*r,u=m*q-n*p,v=Math.sqrt(s*s+t*t+u*u),v?(v=1/v,s*=v,t*=v,u*=v):(s=0,t=0,u=0),this[0]=p,this[1]=s,this[2]=m,this[3]=0,this[4]=q,this[5]=t,this[6]=n,this[7]=0,this[8]=r,this[9]=u,this[10]=o,this[11]=0,this[12]=-(p*d+q*e+r*f),this[13]=-(s*d+t*e+u*f),this[14]=-(m*d+n*e+o*f),this[15]=1;return this},a.toArray=function(){return[this[0],this[1],this[2],this[3],this[4],this[5],this[6],this[7],this[8],this[9],this[10],this[11],this[12],this[13],this[14],this[15]]},b&&a.initMatrix4.apply(a,b);return a},(b.exports=c).create(e)}).call(this)}),a.provide("/Quaternion",function(a,b,c){(function(){function a(a){return this.initQuaternion(a)}"use strict";var c=a.prototype;a.check=function(a){return a&&a.initQuaternion===c.initQuaternion},a.create=function(b){b=b||[],b.length=4,b.initQuaternion=c.initQuaternion||function(a){a=a||[],this[0]=a[0]||0,this[1]=a[1]||0,this[2]=a[2]||0,this[3]=a[3]||0;return this},b.set=function(a){return this.initQuaternion(a)},b.copy=function(){return new a(this)},b.calculateW=function(){var a=this[0],b=this[1],c=this[2];this[3]=-Math.sqrt(Math.abs(1-a*a-b*b-c*c));return this},b.inverse=function(){this[0]*=-1,this[1]*=-1,this[2]*=-1;return this},b.length=function(){var a=this[0],b=this[1],c=this[2],d=this[3];return Math.sqrt(a*a+b*b+c*c+d*d)},b.normalize=function(){var a=this[0],b=this[1],c=this[2],d=this[3],e=Math.sqrt(a*a+b*b+c*c+d*d);e===0?this[0]=this[1]=this[2]=this[3]=0:(e=1/e,this[0]=a*e,this[1]=b*e,this[2]=c*e,this[3]=d*e);return this},b.multiply=function(a){var b=this[0],c=this[1],d=this[2],e=this[3],f=a[0],g=a[1],h=a[2],i=a[3];this[0]=b*i+e*f+c*h-d*g,this[1]=c*i+e*g+d*f-b*h,this[2]=d*i+e*h+b*g-c*f,this[3]=e*i-b*f-c*g-d*h;return this},b.multiplyVec3=function(a){var b=a[0],c=a[1],d=a[2],e=this[0],f=this[1],g=this[2],h=this[3],i=h*b+f*d-g*c,j=h*c+g*b-e*d,k=h*d+e*c-f*b,l=-e*b-f*c-g*d;a[0]=i*h+l*-e+j*-g-k*-f,a[1]=j*h+l*-f+k*-e-i*-g,a[2]=k*h+l*-g+i*-f-j*-e;return this},b.toMat3=function(){var a=this[0],b=this[1],c=this[2],d=this[3],e=a+a,f=b+b,g=c+c,h=a*e,i=a*f,j=a*g,k=b*f,l=b*g,m=c*g,n=d*e,o=d*f,p=d*g;return[1-(k+m),i-p,j+o,i+p,1-(h+m),l-n,j-o,l+n,1-(h+k)]},b.toMat4=function(a){var b=this[0],c=this[1],d=this[2],e=this[3],f=b+b,g=c+c,h=d+d,i=b*f,j=b*g,k=b*h,l=c*g,m=c*h,n=d*h,o=e*f,p=e*g,q=e*h;return[1-(l+n),j-q,k+p,0,j+q,1-(i+n),m-o,0,k-p,m+o,1-(i+l),0,0,0,0,1]},b.slerp=function(a,b){var c=this[0]*this[0]+this[1]*this[1]+this[2]*this[2]+this[3]*this[3];if(Math.abs(c)>=1)return this;var d=Math.acos(c),e=Math.sqrt(1-c*c);if(Math.abs(e)<.001){this[0]=this[0]*.5+a[0]*.5,this[1]=this[1]*.5+a[1]*.5,this[2]=this[2]*.5+a[2]*.5,this[3]=this[3]*.5+a[3]*.5;return this}var f=Math.sin((1-b)*d)/e,g=Math.sin(b*d)/e;this[0]=this[0]*f+a[0]*g,this[1]=this[1]*f+a[1]*g,this[2]=this[2]*f+a[2]*g,this[3]=this[3]*f+a[3]*g;return this},b.toString=b.str=function(){return this.toArray().join(",")},b.toArray=function(){return[this[0],this[1],this[2],this[3]]},b.toFloat32Array=function(){return new Float32Array(this.toArray())},b.toFloat64Array=function(){return new Float64Array(this.toArray())};return b},(b.exports=a).create(c)})()}),function(){"use strict",typeof module!="undefined"?module.exports=a.freeze():a.freeze("glMath",this)}.call(this)}).call(this)